"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var getusermedia_1 = require("webrtc-adapter/src/js/chrome/getusermedia");
var getusermedia_2 = require("webrtc-adapter/src/js/edge/getusermedia");
var getusermedia_3 = require("webrtc-adapter/src/js/firefox/getusermedia");
var safari_shim_1 = require("webrtc-adapter/src/js/safari/safari_shim");
var utils_1 = require("webrtc-adapter/src/js/utils");
var utils_2 = require("@preflower/utils");
exports.default = (0, utils_2.idempotent)(function () {
    var browser = (0, utils_1.detectBrowser)(window).browser;
    switch (browser) {
        case 'chrome':
            (0, getusermedia_1.shimGetUserMedia)(window);
            break;
        case 'firefox':
            (0, getusermedia_3.shimGetUserMedia)(window);
            break;
        case 'edge':
            (0, getusermedia_2.shimGetUserMedia)(window);
            break;
        case 'safari':
            (0, safari_shim_1.shimGetUserMedia)(window);
            break;
        default:
            throw new Error('[react-barcode-scanner]: MediaStream is not supported');
    }
});
